/* ReleaseRow.c generated by valac 0.40.11, the Vala compiler
 * generated from ReleaseRow.vala, do not modify */

/*-
 * Copyright (c) 2017 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Adam Bieńkowski <donadigos159@gmail.com>
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <appstream.h>
#include <stdlib.h>
#include <string.h>
#include <granite.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>


#define APP_CENTER_WIDGETS_TYPE_RELEASE_ROW (app_center_widgets_release_row_get_type ())
#define APP_CENTER_WIDGETS_RELEASE_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APP_CENTER_WIDGETS_TYPE_RELEASE_ROW, AppCenterWidgetsReleaseRow))
#define APP_CENTER_WIDGETS_RELEASE_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), APP_CENTER_WIDGETS_TYPE_RELEASE_ROW, AppCenterWidgetsReleaseRowClass))
#define APP_CENTER_WIDGETS_IS_RELEASE_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APP_CENTER_WIDGETS_TYPE_RELEASE_ROW))
#define APP_CENTER_WIDGETS_IS_RELEASE_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), APP_CENTER_WIDGETS_TYPE_RELEASE_ROW))
#define APP_CENTER_WIDGETS_RELEASE_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), APP_CENTER_WIDGETS_TYPE_RELEASE_ROW, AppCenterWidgetsReleaseRowClass))

typedef struct _AppCenterWidgetsReleaseRow AppCenterWidgetsReleaseRow;
typedef struct _AppCenterWidgetsReleaseRowClass AppCenterWidgetsReleaseRowClass;
typedef struct _AppCenterWidgetsReleaseRowPrivate AppCenterWidgetsReleaseRowPrivate;
enum  {
	APP_CENTER_WIDGETS_RELEASE_ROW_0_PROPERTY,
	APP_CENTER_WIDGETS_RELEASE_ROW_RELEASE_PROPERTY,
	APP_CENTER_WIDGETS_RELEASE_ROW_NUM_PROPERTIES
};
static GParamSpec* app_center_widgets_release_row_properties[APP_CENTER_WIDGETS_RELEASE_ROW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _AppCenterWidgetsReleaseRow {
	GtkListBoxRow parent_instance;
	AppCenterWidgetsReleaseRowPrivate * priv;
};

struct _AppCenterWidgetsReleaseRowClass {
	GtkListBoxRowClass parent_class;
};

struct _AppCenterWidgetsReleaseRowPrivate {
	AsRelease* _release;
	GtkLabel* header_label;
	GtkLabel* description_label;
};


static gpointer app_center_widgets_release_row_parent_class = NULL;

GType app_center_widgets_release_row_get_type (void) G_GNUC_CONST;
#define APP_CENTER_WIDGETS_RELEASE_ROW_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), APP_CENTER_WIDGETS_TYPE_RELEASE_ROW, AppCenterWidgetsReleaseRowPrivate))
AppCenterWidgetsReleaseRow* app_center_widgets_release_row_new (AsRelease* release);
AppCenterWidgetsReleaseRow* app_center_widgets_release_row_construct (GType object_type,
                                                                      AsRelease* release);
gchar* app_center_widgets_release_row_format_release_header (AsRelease* release,
                                                             gboolean with_date);
gchar* app_center_widgets_release_row_format_release_description (AsRelease* release);
AsRelease* app_center_widgets_release_row_get_release (AppCenterWidgetsReleaseRow* self);
static void app_center_widgets_release_row_set_release (AppCenterWidgetsReleaseRow* self,
                                                 AsRelease* value);
static GObject * app_center_widgets_release_row_constructor (GType type,
                                                      guint n_construct_properties,
                                                      GObjectConstructParam * construct_properties);
static void app_center_widgets_release_row_finalize (GObject * obj);
static void _vala_app_center_widgets_release_row_get_property (GObject * object,
                                                        guint property_id,
                                                        GValue * value,
                                                        GParamSpec * pspec);
static void _vala_app_center_widgets_release_row_set_property (GObject * object,
                                                        guint property_id,
                                                        const GValue * value,
                                                        GParamSpec * pspec);


AppCenterWidgetsReleaseRow*
app_center_widgets_release_row_construct (GType object_type,
                                          AsRelease* release)
{
	AppCenterWidgetsReleaseRow * self = NULL;
	g_return_val_if_fail (release != NULL, NULL);
	self = (AppCenterWidgetsReleaseRow*) g_object_new (object_type, "release", release, NULL);
	return self;
}


AppCenterWidgetsReleaseRow*
app_center_widgets_release_row_new (AsRelease* release)
{
	return app_center_widgets_release_row_construct (APP_CENTER_WIDGETS_TYPE_RELEASE_ROW, release);
}


gchar*
app_center_widgets_release_row_format_release_header (AsRelease* release,
                                                      gboolean with_date)
{
	gchar* result = NULL;
	gchar* label = NULL;
	const gchar* version = NULL;
	const gchar* _tmp0_;
	guint64 timestamp = 0ULL;
	gboolean _tmp1_ = FALSE;
	g_return_val_if_fail (release != NULL, NULL);
	_tmp0_ = as_release_get_version (release);
	version = _tmp0_;
	timestamp = as_release_get_timestamp (release);
	if (with_date) {
		guint64 _tmp2_;
		_tmp2_ = timestamp;
		_tmp1_ = _tmp2_ != ((guint64) 0);
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		GDateTime* date_time = NULL;
		guint64 _tmp3_;
		GDateTime* _tmp4_;
		gchar* format = NULL;
		gchar* _tmp5_;
		gchar* date = NULL;
		GDateTime* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		const gchar* _tmp9_;
		_tmp3_ = timestamp;
		_tmp4_ = g_date_time_new_from_unix_utc ((gint64) _tmp3_);
		date_time = _tmp4_;
		_tmp5_ = granite_date_time_get_default_date_format (FALSE, TRUE, TRUE);
		format = _tmp5_;
		_tmp6_ = date_time;
		_tmp7_ = format;
		_tmp8_ = g_date_time_format (_tmp6_, _tmp7_);
		date = _tmp8_;
		_tmp9_ = version;
		if (_tmp9_ != NULL) {
			const gchar* _tmp10_;
			const gchar* _tmp11_;
			gchar* _tmp12_;
			_tmp10_ = version;
			_tmp11_ = date;
			_tmp12_ = g_strdup_printf (_ ("<b>%s</b> – %s"), _tmp10_, _tmp11_);
			_g_free0 (label);
			label = _tmp12_;
		} else {
			const gchar* _tmp13_;
			gchar* _tmp14_;
			_tmp13_ = date;
			_tmp14_ = g_strdup (_tmp13_);
			_g_free0 (label);
			label = _tmp14_;
		}
		_g_free0 (date);
		_g_free0 (format);
		_g_date_time_unref0 (date_time);
	} else {
		const gchar* _tmp15_;
		_tmp15_ = version;
		if (_tmp15_ != NULL) {
			const gchar* _tmp16_;
			gchar* _tmp17_;
			_tmp16_ = version;
			_tmp17_ = g_strdup_printf ("<b>%s</b>", _tmp16_);
			_g_free0 (label);
			label = _tmp17_;
		} else {
			gchar* _tmp18_;
			_tmp18_ = g_strdup (_ ("Unknown version"));
			_g_free0 (label);
			label = _tmp18_;
		}
	}
	result = label;
	return result;
}


static gchar*
string_strip (const gchar* self)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	g_strstrip (_tmp1_);
	result = _result_;
	return result;
}


gchar*
app_center_widgets_release_row_format_release_description (AsRelease* release)
{
	gchar* result = NULL;
	gchar* description = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (release != NULL, NULL);
	_tmp0_ = as_release_get_description (release);
	_tmp1_ = g_strdup (_tmp0_);
	description = _tmp1_;
	_tmp2_ = description;
	if (_tmp2_ != NULL) {
		const gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gboolean _tmp12_;
		{
			gchar* _tmp3_ = NULL;
			const gchar* _tmp4_;
			gchar* _tmp5_;
			gchar* _tmp6_;
			_tmp4_ = description;
			_tmp5_ = as_markup_convert_simple (_tmp4_, &_inner_error_);
			_tmp3_ = _tmp5_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				goto __catch50_g_error;
			}
			_tmp6_ = _tmp3_;
			_tmp3_ = NULL;
			_g_free0 (description);
			description = _tmp6_;
			_g_free0 (_tmp3_);
		}
		goto __finally50;
		__catch50_g_error:
		{
			GError* e = NULL;
			GError* _tmp7_;
			const gchar* _tmp8_;
			e = _inner_error_;
			_inner_error_ = NULL;
			_tmp7_ = e;
			_tmp8_ = _tmp7_->message;
			g_warning ("ReleaseRow.vala:86: %s", _tmp8_);
			_g_error_free0 (e);
		}
		__finally50:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_free0 (description);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp9_ = description;
		_tmp10_ = string_strip (_tmp9_);
		_tmp11_ = _tmp10_;
		_tmp12_ = g_strcmp0 (_tmp11_, "") == 0;
		_g_free0 (_tmp11_);
		if (_tmp12_) {
			gchar* _tmp13_;
			_tmp13_ = g_strdup (_ ("No description available"));
			_g_free0 (description);
			description = _tmp13_;
		}
	} else {
		gchar* _tmp14_;
		_tmp14_ = g_strdup (_ ("No description available"));
		_g_free0 (description);
		description = _tmp14_;
	}
	result = description;
	return result;
}


AsRelease*
app_center_widgets_release_row_get_release (AppCenterWidgetsReleaseRow* self)
{
	AsRelease* result;
	AsRelease* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_release;
	result = _tmp0_;
	return result;
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


static void
app_center_widgets_release_row_set_release (AppCenterWidgetsReleaseRow* self,
                                            AsRelease* value)
{
	g_return_if_fail (self != NULL);
	if (app_center_widgets_release_row_get_release (self) != value) {
		AsRelease* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_release);
		self->priv->_release = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, app_center_widgets_release_row_properties[APP_CENTER_WIDGETS_RELEASE_ROW_RELEASE_PROPERTY]);
	}
}


static GObject *
app_center_widgets_release_row_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	AppCenterWidgetsReleaseRow * self;
	gchar* header = NULL;
	AsRelease* _tmp0_;
	gchar* _tmp1_;
	gchar* description = NULL;
	AsRelease* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	GtkLabel* _tmp5_;
	GtkLabel* _tmp6_;
	GtkLabel* _tmp7_;
	GtkLabel* _tmp8_;
	GtkStyleContext* _tmp9_;
	const gchar* _tmp10_;
	GtkLabel* _tmp11_;
	GtkLabel* _tmp12_;
	GtkLabel* _tmp13_;
	GtkLabel* _tmp14_;
	GtkLabel* _tmp15_;
	GtkLabel* _tmp16_;
	GtkLabel* _tmp17_;
	GtkStyleContext* _tmp18_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp19_;
	GtkGrid* _tmp20_;
	GtkGrid* _tmp21_;
	GtkLabel* _tmp22_;
	GtkGrid* _tmp23_;
	GtkLabel* _tmp24_;
	GtkGrid* _tmp25_;
	parent_class = G_OBJECT_CLASS (app_center_widgets_release_row_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, APP_CENTER_WIDGETS_TYPE_RELEASE_ROW, AppCenterWidgetsReleaseRow);
	_tmp0_ = self->priv->_release;
	_tmp1_ = app_center_widgets_release_row_format_release_header (_tmp0_, TRUE);
	header = _tmp1_;
	_tmp2_ = self->priv->_release;
	_tmp3_ = app_center_widgets_release_row_format_release_description (_tmp2_);
	description = _tmp3_;
	_tmp4_ = header;
	_tmp5_ = (GtkLabel*) gtk_label_new (_tmp4_);
	g_object_ref_sink (_tmp5_);
	_g_object_unref0 (self->priv->header_label);
	self->priv->header_label = _tmp5_;
	_tmp6_ = self->priv->header_label;
	gtk_label_set_use_markup (_tmp6_, TRUE);
	_tmp7_ = self->priv->header_label;
	gtk_label_set_xalign (_tmp7_, (gfloat) 0);
	_tmp8_ = self->priv->header_label;
	_tmp9_ = gtk_widget_get_style_context ((GtkWidget*) _tmp8_);
	gtk_style_context_add_class (_tmp9_, GRANITE_STYLE_CLASS_H3_LABEL);
	_tmp10_ = description;
	_tmp11_ = (GtkLabel*) gtk_label_new (_tmp10_);
	g_object_ref_sink (_tmp11_);
	_g_object_unref0 (self->priv->description_label);
	self->priv->description_label = _tmp11_;
	_tmp12_ = self->priv->description_label;
	gtk_label_set_max_width_chars (_tmp12_, 100);
	_tmp13_ = self->priv->description_label;
	gtk_label_set_selectable (_tmp13_, TRUE);
	_tmp14_ = self->priv->description_label;
	gtk_label_set_use_markup (_tmp14_, TRUE);
	_tmp15_ = self->priv->description_label;
	g_object_set (_tmp15_, "wrap", TRUE, NULL);
	_tmp16_ = self->priv->description_label;
	gtk_label_set_xalign (_tmp16_, (gfloat) 0);
	_tmp17_ = self->priv->description_label;
	_tmp18_ = gtk_widget_get_style_context ((GtkWidget*) _tmp17_);
	gtk_style_context_add_class (_tmp18_, GRANITE_STYLE_CLASS_H3_LABEL);
	_tmp19_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp19_);
	grid = _tmp19_;
	_tmp20_ = grid;
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp20_, 6);
	_tmp21_ = grid;
	_tmp22_ = self->priv->header_label;
	gtk_grid_attach (_tmp21_, (GtkWidget*) _tmp22_, 0, 0, 1, 1);
	_tmp23_ = grid;
	_tmp24_ = self->priv->description_label;
	gtk_grid_attach (_tmp23_, (GtkWidget*) _tmp24_, 0, 1, 1, 1);
	_tmp25_ = grid;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp25_);
	_g_object_unref0 (grid);
	_g_free0 (description);
	_g_free0 (header);
	return obj;
}


static void
app_center_widgets_release_row_class_init (AppCenterWidgetsReleaseRowClass * klass)
{
	app_center_widgets_release_row_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (AppCenterWidgetsReleaseRowPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_app_center_widgets_release_row_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_app_center_widgets_release_row_set_property;
	G_OBJECT_CLASS (klass)->constructor = app_center_widgets_release_row_constructor;
	G_OBJECT_CLASS (klass)->finalize = app_center_widgets_release_row_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), APP_CENTER_WIDGETS_RELEASE_ROW_RELEASE_PROPERTY, app_center_widgets_release_row_properties[APP_CENTER_WIDGETS_RELEASE_ROW_RELEASE_PROPERTY] = g_param_spec_object ("release", "release", "release", as_release_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}


static void
app_center_widgets_release_row_instance_init (AppCenterWidgetsReleaseRow * self)
{
	self->priv = APP_CENTER_WIDGETS_RELEASE_ROW_GET_PRIVATE (self);
}


static void
app_center_widgets_release_row_finalize (GObject * obj)
{
	AppCenterWidgetsReleaseRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, APP_CENTER_WIDGETS_TYPE_RELEASE_ROW, AppCenterWidgetsReleaseRow);
	_g_object_unref0 (self->priv->_release);
	_g_object_unref0 (self->priv->header_label);
	_g_object_unref0 (self->priv->description_label);
	G_OBJECT_CLASS (app_center_widgets_release_row_parent_class)->finalize (obj);
}


GType
app_center_widgets_release_row_get_type (void)
{
	static volatile gsize app_center_widgets_release_row_type_id__volatile = 0;
	if (g_once_init_enter (&app_center_widgets_release_row_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (AppCenterWidgetsReleaseRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) app_center_widgets_release_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AppCenterWidgetsReleaseRow), 0, (GInstanceInitFunc) app_center_widgets_release_row_instance_init, NULL };
		GType app_center_widgets_release_row_type_id;
		app_center_widgets_release_row_type_id = g_type_register_static (gtk_list_box_row_get_type (), "AppCenterWidgetsReleaseRow", &g_define_type_info, 0);
		g_once_init_leave (&app_center_widgets_release_row_type_id__volatile, app_center_widgets_release_row_type_id);
	}
	return app_center_widgets_release_row_type_id__volatile;
}


static void
_vala_app_center_widgets_release_row_get_property (GObject * object,
                                                   guint property_id,
                                                   GValue * value,
                                                   GParamSpec * pspec)
{
	AppCenterWidgetsReleaseRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, APP_CENTER_WIDGETS_TYPE_RELEASE_ROW, AppCenterWidgetsReleaseRow);
	switch (property_id) {
		case APP_CENTER_WIDGETS_RELEASE_ROW_RELEASE_PROPERTY:
		g_value_set_object (value, app_center_widgets_release_row_get_release (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_app_center_widgets_release_row_set_property (GObject * object,
                                                   guint property_id,
                                                   const GValue * value,
                                                   GParamSpec * pspec)
{
	AppCenterWidgetsReleaseRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, APP_CENTER_WIDGETS_TYPE_RELEASE_ROW, AppCenterWidgetsReleaseRow);
	switch (property_id) {
		case APP_CENTER_WIDGETS_RELEASE_ROW_RELEASE_PROPERTY:
		app_center_widgets_release_row_set_release (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



